/*
Class for bitmap based animations
it mirror the MovieClip class with public methods as play, gotoAndPlay etc.
it hijacks the Sprite.rotation property to produce a rotation to the center
but the 
*/

package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.getTimer;
	
	public class BmpMovieClip extends Sprite
	{
		
		public var sheetClass:Class;
		public var canvas:BitmapData;
		public var canvasClearRect:Rectangle;
		public var spritesheet:BitmapData;
		public var rect:Rectangle;
		
		public var totalFrames:Number;		
		public var currentFrame:int = 0;
		
		public var smoothPixels:Boolean = true;
		public var angle:Number = 0;
		
		private var playing:Boolean = true;
		
		private var sW:Number;
		private var sH:Number;
		private var tW:Number;
		private var tH:Number;
				
		private var tickPosition:int = 0;
		private var tickLastPosition:int = -1;
		private var framePeriod:int = 66;//33; // 1000 / 20 - (1 sec / frame rate)
		
		private var bitmapRotation:int = 0;
      	private var bitmapRotationMatrix:Matrix;
      	private var startLocation:Point = new Point(84, 84);
	
		
		public function BmpMovieClip(sc:Class, sheetWidth:Number, sheetHeight:Number, tileWidth:Number)
		{
			sheetClass = sc;
			sW = sheetWidth;
			sH = sheetHeight;
			tW = tileWidth;
			tH = sH;
			
			
			
			if(sW % tW!=0)
				trace("Warning: tile size / sheet size error");
			
			totalFrames = int(sW/tW);
			
			addEventListener(Event.ADDED_TO_STAGE,init);
		}
		
		/**
		 * 	Initialize method
		 */
		private function init(evt:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE,init);
			
			stage.addEventListener(Event.ENTER_FRAME, routine);
			
			// Set our game timer to the stage frameRate
			framePeriod = int(1000 / stage.frameRate);
			
			// Create input bitmap instance
			spritesheet = (new sheetClass() as Bitmap).bitmapData;
			
			// Add a Bitmap to the display list that will copyPixels() to.
			canvas = new BitmapData(sW, sH, true, 0xFFFFFF);
			addChild(new Bitmap(canvas));
			
			canvasClearRect = new Rectangle(0, 0, sW, sH);
			// Tile Size
			rect = new Rectangle(0, 0, tW, tH);
		}
		
		/**
		 * 	Handles the timer
		 */
		private function routine(event:Event):void
		{
		if(rotation != angle)
			angle = rotation;
			
		rotation = 0;
				
		tickPosition = int((getTimer() % 1000) / framePeriod);
			
			if (tickLastPosition != tickPosition)
			{
				tickLastPosition = tickPosition;
				canvas.lock();
				canvas.fillRect(canvasClearRect, 0x000000);
				render(angle);
				canvas.unlock();
			}
		}
		
		public function play():void
		{
		playing = true;
		}
		
		public function stop():void
		{
		playing = false;
		}
		
		public function gotoAndPlay(frame:Number):void
		{
		playing = true;
		currentFrame = frame;
		}
		
		public function gotoAndStop(frame:Number):void
		{
		playing = false;
		currentFrame = frame;
		}
		
		
		//render bmp with rotation
		public function render(degrees:Number):void
		{
		
		rect.x = (currentFrame % totalFrames) * tW;
		rect.y = int(currentFrame / totalFrames) * tH;
		
		var temp:BitmapData = new BitmapData(tW, tH, true, 0xFFFFFF);
		temp.copyPixels(spritesheet, rect, new Point(0, 0), null, null, true);
		
		if(playing)	
			currentFrame = ++currentFrame % totalFrames;
			
		var angle_in_radians:Number = Math.PI * 2 * (degrees / 360);
		var rotationMatrix:Matrix = new Matrix();
		rotationMatrix.translate(-tW/2,-tH/2);
		rotationMatrix.rotate(angle_in_radians);
		rotationMatrix.translate(tW/2,tH/2);
		canvas.draw(temp, rotationMatrix, null, null, null, smoothPixels);
		}
		
		
	}
}