/*
Generic class for special effects like explosions
by default it self destruct when it reaches the end of the animation
*/

package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;

	public class Fx extends Sprite
	{
	[Embed(source='assets/animations.swf', symbol='Explosion')]
	private var Explosion_animation:Class;
	
	public var animation:MovieClip;
	
	public var vX:Number = 0;
	public var vY:Number = 0;
	
	public var disappearAtTheEnd:Boolean = true;
	
	//margin for self destruction
	public var marginTop:Number;
	public var marginBottom:Number;
	public var marginLeft:Number;
	public var marginRight:Number;
	
		public function Fx()
		{
		super();
		animation = new Explosion_animation();
		addChild(animation);
		
		addEventListener(Event.ADDED_TO_STAGE,init);
		}
		
		public function init(e:Event):void
		{
		if(isNaN(marginTop))
			marginTop = 0;
			
		if(isNaN(marginBottom))
			marginBottom = stage.stageHeight;
			
		if(isNaN(marginLeft))
			marginLeft = 0;
			
		if(isNaN(marginRight))
			marginRight = stage.stageWidth;
		
		addEventListener(Event.ENTER_FRAME, routine);
		}
		
		public function routine(e:Event):void
		{
		//move
		x += vX;
		y += vY;
		
		//check margin
		if(x>marginRight+width)
			destroy();	
		
		if(y>marginBottom+height)
			destroy();	
		
		if(x<marginLeft - width)
			destroy();
		
		if(y<marginTop-height)
			destroy();
			
		if(disappearAtTheEnd && animation.currentFrame == animation.totalFrames)
			destroy();
		}
		
		public function destroy():void
		{
		removeEventListener(Event.ENTER_FRAME, routine);
		
		if(this.parent != null)
			this.parent.removeChild(this);
		}
	}
}