/*
This class manages music loops allowing an offset at the beginning and at the end to remove clicks and gaps

(based on a Jeff Fulton class)
*/
package  
{
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.media.*;
	import flash.utils.Timer;

	public class Loop extends Sprite
	{
		public var snd:Sound; 
        public var sndChannel:SoundChannel;
		
		public var offsetIn:int;
		public var offsetOut:int;
		
		private var placeToStop:int;
		private var soundTimer:Timer;
		
		public var isPlaying:Boolean = true;
			
		public function Loop(sndCls:Class, offIn:Number = 0, offOut:Number = 10):void
		{
		offsetIn = offIn;
		offsetOut = offOut;
			
		snd = new sndCls() as Sound;
			 
		placeToStop = snd.length-offsetOut;
			
		sndChannel = snd.play(offsetIn);
		soundTimer=new Timer(1);
		soundTimer.addEventListener(TimerEvent.TIMER, repeat);
		soundTimer.start();
		
		}
		
		public function repeat(e:Event):void 
		{
		if(isPlaying)
			{
			if (int(sndChannel.position) >= placeToStop) 
				{
				sndChannel.stop();
				sndChannel = snd.play(offsetIn);
				}
			}
		}
		
		public function play():void {
		if(!isPlaying)
			{
			isPlaying = true;
			sndChannel = snd.play(offsetIn);
			}
		}
		
		public function stop():void {
		sndChannel.stop();
		isPlaying = false;
		}
		
		

		
	}
	
}

