package
{
	import com.coreyoneil.collision.CollisionList;
	
	import flash.display.Sprite;
	import flash.events.*;
	
	
	public class Thing extends Sprite
	{
	
	[Embed(source='assets/animations.swf', symbol='Asteroid')]
	private var Asteroid_animation:Class;
	
	public var animation:Sprite;
	
	
	public var vX:Number = -3;
	public var vY:Number = 0;
	public var rotateToDirection:Boolean = true;
	public var cList:CollisionList; //reference to collision list
	public var tList:CollisionList; //reference to target list
	
	//margin for self destruction
	public var marginTop:Number;
	public var marginBottom:Number;
	public var marginLeft:Number;
	public var marginRight:Number;
	
	
	
		public function Thing()
		{
		super();
		
		animation = new Asteroid_animation();
		
		addChild(animation);
			
		
		addEventListener(Event.ADDED_TO_STAGE,init);
		}
		
		public function init(e:Event):void
		{
		if(isNaN(marginTop))
			marginTop = 0;
			
		if(isNaN(marginBottom))
			marginBottom = stage.stageHeight;
			
		if(isNaN(marginLeft))
			marginLeft = 0;
			
		if(isNaN(marginRight))
			marginRight = stage.stageWidth;
		
		addEventListener(Event.ENTER_FRAME, routine);
		}
		
		
		public function routine(e:Event):void
		{
		
		//move
		x += vX;
		y += vY;
		
		//if(rotateToDirection && Math.sqrt(vX*vX + vY*vY)>0.5 )
		//	animation.rotation = Math.atan2(vX, vY) / Math.PI * 180;
		
		//check margin
		if(x>marginRight+width)
			destroy();	
		
		if(y>marginBottom+height)
			destroy();	
		
		if(x<marginLeft - width)
			destroy();
		
		if(y<marginTop-height)
			destroy();
		}
		
		public function collide(obj:Object):void
		{
		//trace(this + " collides with "+obj);
		
		var fx:Fx = new Fx();
		fx.x = x;
		fx.y = y;
		
		if(this.parent != null)
			this.parent.addChild(fx);
		
		if(this.parent != null)
			this.parent.removeChild(this);
		
		destroy();
		}
		
		public function destroy():void
		{
		if(cList!=null)
			cList.removeItem(this);
			
		if(tList!=null)
			tList.removeItem(this);
		
		removeEventListener(Event.ENTER_FRAME, routine);
		}
	}
}