package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.getTimer;
	
	
	
	public class BmpSprite extends Sprite
	{
			
		public var sheetClass:Class;
		public var canvas:BitmapData;
		public var canvasClearRect:Rectangle;
		public var spritesheet:BitmapData;
		public var rect:Rectangle;
		
		private var sW:Number;
		private var sH:Number;
		private var tW:Number;

	

		private var frames:Number;		
		private var currentTile:int = 0;
		private var tickPosition:int = 0;
		private var tickLastPosition:int = -1;
		private var framePeriod:int = 66;//33; // 1000 / 20 - (1 sec / frame rate)
		
		public function BmpMovieClip(sc:Class, sheetWidth:Number, sheetHeight:Number, tileWidth:Number)
		{
			sheetClass = sc;
			sW = sheetWidth;
			sH = sheetHeight;
			tW = tileWidth;
			
			
			if(sW % tW!=0)
				trace("Warning: tile size / sheet size error");
			
			frames = int(sW/tW);
			
			addEventListener(Event.ADDED_TO_STAGE,init);
		}
		
		/**
		 * 	Initialize method
		 */
		private function init(evt:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE,init);
			
			stage.addEventListener(Event.ENTER_FRAME, enterFrameHandler);
			
			// Set our game timer to the stage frameRate
			framePeriod = int(1000 / stage.frameRate);
			
			// Create input bitmap instance
			spritesheet = (new sheetClass() as Bitmap).bitmapData;
			
			// Add a Bitmap to the display list that will copyPixels() to.
			canvas = new BitmapData(sW, sH, true, 0xFFFFFF);
			addChild(new Bitmap(canvas));
			
			canvasClearRect = new Rectangle(0, 0, sW, sH);
			// Tile Size
			rect = new Rectangle(0, 0, tW, sH);
		}
		
		/**
		 * 	Handles the timer
		 */
		private function enterFrameHandler(event:Event):void
		{
			tickPosition = int((getTimer() % 1000) / framePeriod);
			
			if (tickLastPosition != tickPosition)
			{
				tickLastPosition = tickPosition;
				canvas.lock();
				canvas.fillRect(canvasClearRect, 0x000000);
				render();
				canvas.unlock();
			}
		}
		
		/**
		 * 	Render any bitmap data.
		 */
		private function render():void
		{			
			rect.x = (currentTile % frames) * tW;
			rect.y = int(currentTile / frames) * sH;
		
			canvas.copyPixels(spritesheet, rect, 
			new Point(0, 0), null, null, true);
			
			currentTile = ++currentTile % frames;
		}
		
		
	}
}