package
{
	import com.coreyoneil.collision.CollisionList;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.*;
	
	public class Emitter extends Sprite
	{
	public var className:String;
	public var minX:Number = 0;
	public var maxX:Number = 100;
	public var minY:Number = 0;
	public var maxY:Number = 100;
	public var checkOverlapping:Boolean = true;
	public var emissionRate:Number = 10; //emit every n frames
	public var emissionCertainty:Number = 50; //0 to 100 - 0 never, 100 always
	public var cList:CollisionList; //all the emitted object can be assigned to this list
	public var tList:CollisionList; //all the emitted object can be assigned to this list
	
	
	private var cycle:Number = 0;
	
		public function Emitter()
		{
			super();	
			addEventListener(Event.ENTER_FRAME, loop);
		}
		
		public function loop(e:Event):void
		{
		if(cycle%emissionRate==0)
			if(Math.round(Math.random()*100) < emissionCertainty)
				emit();
			
		cycle++;
		}
		
		public function emit():void
		{
		//create a new "enemy"
		var ClassReference:Class = getDefinitionByName(className) as Class;
       	var obj:* = (new ClassReference() as Sprite);
 
        if(cList!=null)
        	{
        	//pass the reference
        	obj.cList = cList;
        	cList.addItem(obj);
        	}
        
        if(tList!=null)
        	{
        	//pass the reference
        	obj.tList = tList;
        	tList.addItem(obj);
        	}
        	
        
        addChild(obj);

		//overlapping
        if(checkOverlapping)
        {
        var over:Boolean = true;
        var safeCount:Number = 0
        //rerandomize until not over
        while(over && safeCount<10)
	        {
	        
	        obj.x = Math.floor(Math.random() * (maxX - minX + 1)) + minX;
			obj.y = Math.floor(Math.random() * (maxY - minY + 1)) + minY;		
	        
	        //once placed verify overlapping with all the objects in the same container
	        var chk:Boolean = false;
	        for (var i:int=0; i < numChildren && !chk; i++) 
	        {
	        //check with obj of the same class
			if(getChildAt(i) is ClassReference && !chk && getChildAt(i) != obj)
				chk = obj.hitTestObject(getChildAt(i));
			}
			
			over = chk;
			safeCount++;
			}
			
		//if still over probably impossible to NOT overlap, cancel the emission
		if(over)
			{
			obj.destroy();
			}
			
        }//check overlapping
		
		}
		
	}
}